#!/usr/bin/env python
import sys, os
sys.path.append('/usr/share/inkscape/extensions')

import inkex
from simplestyle import *

class GIFAnimate(inkex.Effect):
	def __init__(self):
		inkex.Effect.__init__(self)
	
	def effect(self):
		infile = sys.argv[-1]

		# Get access to main SVG document element and get its dimensions.
		from xml.dom.minidom import parse, parseString
		dom = parse(infile)
		svg = dom.getElementsByTagName('svg')[0]
		
		layers = svg.getElementsByTagName('g')
		pngcommand = "inkscape %s -C -i '%s' -j -e /tmp/%s.png 2>&1 > /dev/null"
		
		layerids = []
		delays = []
		for l in layers:
			bits = l.getAttribute('inkscape:label').split("#")
			if not "ignore" in bits:
				layerids.append(l.getAttribute('id'))
				delays.append(bits[0])
		
		[os.system(pngcommand % (infile, id, id)) for id in layerids]
		bits = " ".join(["-delay %d /tmp/%s.png" % (int(delays[x]), layerids[x]) for x in range(len(layerids))])
		gifcmd = "convert -loop 0 " + bits + " /tmp/inkscape-anim.gif"
		os.system(gifcmd)
		import webbrowser
		webbrowser.open("file:///tmp/inkscape-anim.gif")

# Create effect instance and apply it.
effect = GIFAnimate()
effect.affect()
