from PodSix.Resource import *
from PodSix.Concurrent import Concurrent

class Widget(EventMonitor, Concurrent):
	"""
		Base class that all GUI widgets inherit from.
	"""
	def __init__(self):
		Concurrent.__init__(self)
		EventMonitor.__init__(self)
		self.triggered = False
	
	def Pump(self):
		self.triggered = False
		Concurrent.Pump(self)
		EventMonitor.Pump(self)
	
	def InRect(self, pos):
		if self.rect:
			return pos[0] < self.rect.right and pos[0] > self.rect.left and pos[1] < self.rect.bottom and pos[1] > self.rect.top
