from PodSix.Concurrent import Concurrent

class Layer(Concurrent):
	def __init__(self, level):
		Concurrent.__init__(self)
		self.level = level
		self.platforms = []
		self.ladders = []
		self.portals = []
		self.items = []
		self.names = {}
	
	def GetAll(self):
		return self.ladders + self.portals + self.platforms + self.items
	
	def Draw(self):
		#print self.level.camera.GetVisible()
		[o.Draw() for o in self.objects if hasattr(o, "Draw") and o in self.level.camera.GetVisible()]
	
	def AddProp(self, prop):
		self.Add(prop)
		getattr(self, prop.type + "s").append(prop)
		self.names[prop.id] = prop
		prop.SetContainer(self)
		return prop
	
	def RemoveProp(self, prop):
		self.Remove(prop)
		getattr(self, prop.type + "s").remove(prop)
		del self.names[prop.id]
		prop.SetContainer(None)
		return prop
	
