from VectorShape import *

class VectorSprite:
	"""
		Sprite made up of several VectorShapes.
	"""
	shapeClass = VectorShape
	
	def __init__(self, sprite=None):
		self.size = [1.0, 1.0]
		if sprite:
			self.shapes = [self.shapeClass(s.points, self) for s in sprite.shapes]
		else:
			self.shapes = []
	
	def New(self, points):
		self.shapes.append(self.shapeClass(points, self))
		return self.shapes[-1]
	
	def SetSize(self, size):
		self.size = size[:]
	
	def Draw(self):
		[s.Draw() for s in self.shapes]
	

